from datetime import datetime
from typing import Optional

from cpl_core.database import TableABC

from bot_data.model.auth_user import AuthUser
from bot_data.model.user import User
from bot_data.model.server import Server


class AuthUserUsersRelation(TableABC):

    def __init__(self, auth_user: AuthUser, user: User, created_at: datetime = None, modified_at: datetime = None):
        self._auth_user = auth_user
        self._user = user

        TableABC.__init__(self)
        self._created_at = created_at if created_at is not None else self._created_at
        self._modified_at = modified_at if modified_at is not None else self._modified_at

    @property
    def auth_user(self) -> AuthUser:
        return self._auth_user

    @auth_user.setter
    def auth_user(self, value: AuthUser):
        self._auth_user = value

    @property
    def user(self) -> User:
        return self._user

    @user.setter
    def user(self, value: User):
        self._user = value

    @staticmethod
    def get_select_all_string() -> str:
        return str(f"""
            SELECT * FROM `AuthUserUsersRelations`;
        """)

    @staticmethod
    def get_select_by_auth_user_id_string(id: int) -> str:
        return str(f"""
            SELECT * FROM `AuthUserUsersRelations`
            WHERE `AuthUserId` = {id};
        """)

    @staticmethod
    def get_select_by_user_id_string(id: int) -> str:
        return str(f"""
            SELECT * FROM `AuthUserUsersRelations`
            WHERE `UserId` = {id};
        """)

    @property
    def insert_string(self) -> str:
        return str(f"""
            INSERT INTO `AuthUserUsersRelations` (
                `AuthUserId`, `UserId`, `CreatedAt`, `LastModifiedAt`
            ) VALUES (
                {self._auth_user.id},
                {self._user.user_id},
                '{self._created_at}',
                '{self._modified_at}'
            );
        """)

    @property
    def udpate_string(self) -> str:
        return str(f"""
            UPDATE `AuthUserUsersRelations`
            SET `AuthUserId` = '{self._auth_user.id}',,
            `UserId` = '{self._user.user_id}'
            `LastModifiedAt` = '{self._modified_at}'
            WHERE `AuthUserId` = {self._auth_user.id}
            AND `UserId` = {self._user.user_id};
        """)

    @property
    def delete_string(self) -> str:
        return str(f"""
            DELETE FROM `AuthUserUsersRelations`
            WHERE `AuthUserId` = {self._auth_user.id}
            AND `UserId` = {self._user.user_id};
        """)
